require "Functions"

--------------------------------------------------------------
--------------------------------------------------------------
--main to show GUI
--------------------------------------------------------------
--------------------------------------------------------------

function show_control_panel()

  --1 dialog at a time
  if (my_dialog and my_dialog.visible) then -- only allows one dialog instance
    my_dialog:close()
    return
  end
  
  --reset vb otherwise old one is not released sometimes???
  vb = renoise.ViewBuilder()

  --create automation envelopes        
  create_automation_envelopes_all_tracks()
  
  --add notifier for current track --EXCHANGE FOR SELECTED ENVELOPE NOTIFIER FUNCTION
  add_notifiers_and_timers()
  
  ------------  
  --Build GUI
  ------------
  
  local title = "Auto. Control Panel"
  local dialog_content = vb:column {
  
  --text
  vb:horizontal_aligner{
   mode = "center",
   vb:text{
   text = "Refresh Tool or Current Track:"
   }
  },
  --Create/Delete Buttons
  vb:horizontal_aligner{
   mode = "center",
   vb:button{
    color = {00,99,20},
    text = "Re-Initialize",
    notifier = function() --no need to choose envelope for this button as it resets the whole tool
                 remove_dummy_devices()
                create_automation_envelopes_all_tracks()
                end
                ,
   width = 90,
   height = 15
       
    },
    vb:button{
    color = {60,60,150},
    text = "Refresh Current",
    notifier = function() update_selected_envelope_from_pattern() end
    }
    
    
  --[[ vb:button{
    color = {100,40,40},
    text = "Exit",
    notifier = release_doc_house_keeping,
    width = 80,
    height = 15
    }  --]] 
   },--end buttons row
  --text 
  --[[vb:horizontal_aligner{
   mode = "center",
  vb:text{
   text = "Choose Column Type To Adjust:"
   }
  },
  
  vb:horizontal_aligner{
   mode = "center",
   vb:switch{
    items = {"VEL","PAN","DLY"},
    width = 118
    }
   },--end switch row--]]

  
   vb:horizontal_aligner{
   mode = "center",
   vb:text{
    text = "Alternative Undo/Redo:"
   },
  },
  vb:horizontal_aligner{
   mode = "center",
   vb:button{
    color = {99,99,50},
    width = 80,
    height = 15,
    text = "Safe Undo",
    notifier = function() alt_undo(true) end
    },

   vb:button{
    color = {99,99,50},
    width = 80,
    height = 15,
    text = "Safe Redo",
    notifier = function() alt_undo(false) end,
    }
   },--end of button row

  --text 
   vb:horizontal_aligner{
   mode = "center", 
   vb:text{
   text = "Set All in Col. / Apply To All Col.s"   
   },
  },--SLIDER
  vb:horizontal_aligner{
   mode = "distribute",
   vb:slider{
    min = 0,
    max = 128,
    notifier = function(value)
                 --round value
                 value = round(value, 0)
                 --pass to function --in non_spec.lua
                 set_all_values_in_column(value)
               end, 
    id = "slider"
    },

   vb:checkbox{
    value = false,
    notifier = function(value) flag_all_columns = value end,
    }
  },--horizontal aligner
  vb:horizontal_aligner{
   mode = "center",
  vb:text{
   font = "bold",
   text = tostring(vb.views["slider"].value), --used as a spacer
   id = "val text"
    }
   },
 }--end column
  
  --show dialog
  my_dialog = renoise.app():show_custom_dialog(title, dialog_content,my_keyhandler_func)

end

 --key Handler
function my_keyhandler_func(dialog, key)
  --focus renoise hack
  renoise.app().window.lock_keyboard_focus = false
  renoise.app().window.lock_keyboard_focus = true
  --return any key to renoise
  return key
end

--Thisfunction called regularly by write_envelope_to_pattern() which is on a timer.
--when the tool GUI is exited via the [X] on the GUI it will close the tool and delete
--all the dummy devices
function close_gui_on_invisible()
  --1 dialog at a time
  if not my_dialog.visible then -- only allows one dialog instance
    remove_dummy_devices()
    renoise.app():show_status("Meta From Automation: (Tool Exited) GUI.lua")
    return
  end
end  

-----------------------------------------------
--Helper to convert dec to hex
-----------------------------------------------
function num_to_hex_string(num)

 num = tostring(num)
 num = string.format("%X",num)
 
-- if #num < 2 then
 --  return tostring("0x0"..num)
-- end
 return tostring(num) --string
end

--helper to round number to specified decimal place
function round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end



