--make bottom half of editor zoom

--value constants
--VEL_MAX = 128
--VEL_EMPTY = 255

--PAN_MAX = 128
--PAN_CENTRE = 64 
--PAN_EMPTY = 255

--DLY_MAX = 255
--DLY_EMPTY = 0


--vals 0 to 0.5 range for
--volume:  0 -> (VEL_MAX/4)
--panning: 0 -> (PAN_MAX/4)
--delay :  0 -> (DLY_MAX/4)

--vals 0.5 to 1 range for
--volume:  (VEL_MAX/4) -> 3*(VEL_MAX/4)
--panning: (PAN_MAX/4) -> 3*(PAN_MAX/4)
--delay :  (DLY_MAX/4) -> 3*(DLY_MAX/4)

zoom_lower = false

--(enveope->pattern)
--function takes envelope value and scales it to the zoom factor
--takes a parameter(value) note/pan/delay value 0-128 or 255 
function wtp_zoom_env_lower_half(value)
  
  --return unchanged value if no lower zoom is set
  if not zoom_lower then
    return value
  end
  
  local song = renoise.song()
  
  --ERROR MESSAGE NEEDED?
  if not song.selected_parameter then
    return value
  end
  
  if song.selected_parameter.name == "VEL" then

  --return with no change if an empty slot value
    if value == VEL_EMPTY then
      return value
    end
    --calculate
    --when value is under half way in envelop then scale it down by half
    --gives double resolution for bottom half of envelope
    if value <= (VEL_MAX/2) then
      value = value / 2
    else 
    --when in top half of envelope reduce resolution by 1.5
      value = (1.5 * value) - 64
    end
    return value
  end

  if song.selected_parameter.name == "PAN" then
    --calculate
    --when value is under half way in envelop then scale it down by half
    --gives double resolution for bottom half of envelope
    if value <= (PAN_MAX/2) then
      value = value / 2
    else 
    --when in top half of envelope reduce resolution by 1.5
      value = (1.5 * value) - 64
    end
    return value
  end
  
  if song.selected_parameter.name == "DLY" then
    --calculate
    --when value is under half way in envelop then scale it down by half
    --gives double resolution for bottom half of envelope
    if value <= (DLY_MAX/2) then
      value = value / 2 --(2x zoom )
    else 
    --when in top half of envelope reduce resolution by 1.5
      value = (1.5 * value) - 128
    end
    return value
  end
end
---------------------------------------------------------------------------------
---------------------------------------------------------------------------------
--(pattern -> envelope)
function wte_zoom_env_lower_half(value)

  --return unchanged value if no lower zoom is set
  if not zoom_lower then
    return value
  end
  
  local song = renoise.song()

  if song.selected_parameter.name == "VEL" then
  
    if value <= 0.25 then
      --double the values in the lower half of the envelope
      --for finer control (x2 zoom level)
      value = value * 2
    else
      --scale value to start from zero
      value = (value - 0.25)
      --reduce value by 1/3 and set it to start from 0.5 (mid envelope)
      value = 0.5 + (value*(2/3))
    end
    return value
  end

  if song.selected_parameter.name == "PAN" then
  
    if value <= 0.25 then
      --double the values in the lower half of the envelope
      --for finer control (x2 zoom level)
      value = value * 2
    else
      --scale value to start from zero
      value = (value - 0.25)
      --reduce value by 1/3 and set it to start from 0.5 (mid envelope)
      value = 0.5 + (value*(2/3))
    end
    return value
  end
  
  if song.selected_parameter.name == "DLY" then
  
    if value <= 0.25 then
      --quadruple the values in the lower half of the envelope
      --for finer control (x2 zoom level)
      value = value * 2
    else
      --scale value to start from zero
      value = (value - 0.25)
      --reduce value by 1/3 and set it to start from 0.5 (mid envelope)
      value = 0.5 + (value*(2/3))
    end
    return value
  end
end 


--function takes envelope value and scales it to the zoom factor
function zoom_env_upper_half()
end
