--main.lua contains keybinds/menus/startup-notifiers, and relevant functions

--import other files
require "GUI"
require "extra_shortcuts"

--functions
--------------------------------------------------------------------------------
--checks for dummy devices (vel,pan,dly) and fires up/ deletes tool accordingly
--------------------------------------------------------------------------------
function toggle_control_panel()

  --toggle by checking for dummy devices
  if check_for_present_dummy_devices() then
   --if no dialog is present i.e. devices are left in song from previous session
   --remove them but re-initiate the tool
   if not (my_dialog and my_dialog.visible) then 
      remove_devices_and_dialog()
      show_control_panel() --in GUI.lua
      renoise.app():show_status("`Vel Pan Dly` Tool: (Devices And Automation Added)")
    --else close the tool as it was active
    else
      remove_devices_and_dialog()
      renoise.app():show_status("`Vel Pan Dly` Tool: (Devices And Automation Removed)")
    end
  else--initiate the tool if no dummy devices found atall
    show_control_panel()
    renoise.app():show_status("`Vel Pan Dly` Tool: (Devices And Automation Added)")  
  end
end  

---------------------------------------------------------------------------------
---------------------------------------------------------------------------------

--keybindings-------
renoise.tool():add_keybinding {
  name = "Global:Tools:`VPD` Alternative Undo",  
  invoke = function() alt_undo(true)
  end  
}

renoise.tool():add_keybinding {
  name = "Global:Tools:`VPD` Alternative Redo",  
  invoke = function() alt_undo(false)
  end  
}

renoise.tool():add_keybinding {
  name = "Global:Tools:`VPD` Toggle Envelopes and Control Panel",  
  invoke = function() toggle_control_panel()
  end  
}

renoise.tool():add_keybinding {
  name = "Global:Tools:`VPD` Refresh Current Pattern Track",  
  invoke = function() update_selected_envelope_from_pattern()
  end  
}

--menu entries-------
renoise.tool():add_menu_entry {
  name = "Main Menu:Tools:Ledger`s Scripts:Toggle Vel Pan Dly Envelopes and Control Panel..",  
  invoke =  function() toggle_control_panel()
  end 
}

renoise.tool():add_keybinding {
  name = "Global:Tools:`VPD` Toggle Column Solo",  
  invoke = function() toggle_column_solo()
  end  
}




--------
--------------------------------------------
--notifiers when tool is loaded with renoise
--------------------------------------------
--------

function remove_devices_and_dialog()
  --remove all devices and notifiers
  remove_dummy_devices()
  --close GUI
  if (my_dialog and my_dialog.visible) then -- only allows one dialog instance
    my_dialog:close()
    return
  end
end 
----------------------------
--release document notifier
---------------------------
if not renoise.tool().app_release_document_observable:has_notifier(remove_devices_and_dialog) then
  renoise.tool().app_release_document_observable:add_notifier(remove_devices_and_dialog)
end



